angular.module('focaModalCobranza')
    .controller('focaModalCobranzaController', 
        [
            '$timeout',
            '$filter',
            '$scope',
            '$uibModalInstance',
            'focaModalCobranzaService',
            function($timeout, $filter, $scope, $uibModalInstance, focaModalCobranzaService) {
                var fecha = new Date();
                $scope.fechaHasta = new Date();
                $scope.fechaDesde = new Date(fecha.setMonth(fecha.getMonth() - 1));
                $scope.filters = '';
                $scope.cobranzas = [];
                $scope.primerBusqueda = false;
                $scope.searchLoading = false;
                // pagination
                $scope.numPerPage = 10;
                $scope.currentPage = 1;
                $scope.filteredCobranzas = [];
                $scope.currentPageCobranzas = [];
                $scope.selectedCobranza = -1;

                //METODOS
                $scope.busquedaPress = function(key) {
                    if (key === 13) {
                        //TODO Validaciones con alertas de foca
                        if(!$scope.fechaDesde) {
                            alert('INGRESE FECHA DESDE');
                            return;
                        }
                        if(!$scope.fechaHasta) {
                            alert('INGRESE FECHA HASTA');
                            return;
                        }
                        if($scope.fechaDesde > $scope.fechaHasta) {
                            alert('La fecha desde no puede ser mayor a la fecha hasta');
                            return;
                        }
                        $scope.searchLoading = true;
                        //TODO: usar filtros en vez de toISOString
                        focaModalCobranzaService
                            .getCobranzas($scope.fechaDesde.toISOString().split('.')[0],
                                $scope.fechaHasta.toISOString().split('.')[0])
                            .then(llenarDatos);
                    }
                };
                function llenarDatos(res) {
                    $scope.cobranzas = [];
                    $scope.filteredCobranzas = [];
                    $scope.currentPageCobranzas = [];
                    $scope.selectedCobranza = -1;
                    $scope.searchLoading = false;
                    $scope.primerBusqueda = true;
                    $scope.cobranzas = res.data;
                    $scope.search(true);
                    primera();
                }
                $scope.search = function(pressed) {
                    if($scope.cobranzas.length > 0) {
                        $scope.filteredCobranzas = $filter('filter')(
                            $scope.cobranzas,
                            {$: $scope.filters}
                        );

                        if(pressed && $scope.filteredCobranzas.length === 0){
                            $timeout(function() {
                                angular.element('#search')[0].focus();
                                $scope.filters = '';
                            });
                        }

                        $scope.lastPage = Math.ceil(
                            $scope.filteredCobranzas.length / $scope.numPerPage
                        );

                        $scope.resetPage();
                    }
                };

                $scope.resetPage = function() {
                    $scope.currentPage = 1;
                    $scope.selectPage(1);
                };

                $scope.selectPage = function(page) {
                    var start = (page - 1) * $scope.numPerPage;
                    var end = start + $scope.numPerPage;
                    $scope.paginas = [];
                    $scope.paginas = calcularPages(page);
                    $scope.currentPageCobranzas = $scope.filteredCobranzas.slice(start, end);
                    $scope.currentPage = page;
                };

                $scope.select = function(cobranza) {
                    $uibModalInstance.close(cobranza);
                };

                $scope.cancel = function() {
                    $uibModalInstance.dismiss('cancel');
                };

                $scope.busquedaDown = function(key) {
                    if (key === 40) {
                        primera(key);
                    }
                };

                $scope.itemCobranza = function(key) {
                    if (key === 38) {
                        anterior(key);
                    }

                    if (key === 40) {
                        siguiente(key);
                    }

                    if (key === 37) {
                        retrocederPagina();
                    }

                    if (key === 39) {
                        avanzarPagina();
                    }
                };

                function calcularPages(paginaActual) {
                    var paginas = [];
                    paginas.push(paginaActual);

                    if (paginaActual - 1 > 1) {
                        
                        paginas.unshift(paginaActual - 1);
                        if (paginaActual - 2 > 1) {
                            paginas.unshift(paginaActual - 2);
                        }
                    }

                    if (paginaActual + 1 < $scope.lastPage) {
                        paginas.push(paginaActual + 1);
                        if (paginaActual + 2 < $scope.lastPage) {
                            paginas.push(paginaActual + 2);
                        }
                    }

                    if (paginaActual !== 1) {
                        paginas.unshift(1);
                    }

                    if (paginaActual !== $scope.lastPage) {
                        paginas.push($scope.lastPage);
                    }

                    return paginas;
                }

                function primera() {
                    $scope.selectedCobranza = 0;
                }

                function anterior() {
                    if ($scope.selectedCobranza === 0 && $scope.currentPage > 1) {
                        retrocederPagina();
                    } else {
                        $scope.selectedCobranza--;
                    }
                }

                function siguiente() {
                    if ($scope.selectedCobranza < $scope.currentPageCobranzas.length - 1 ) {
                        $scope.selectedCobranza++;
                    } else {
                            avanzarPagina();
                    }
                }

                function retrocederPagina() {
                    if ($scope.currentPage > 1) {
                        $scope.selectPage($scope.currentPage - 1);
                        $scope.selectedCobranza = $scope.numPerPage - 1;
                    }
                }

                function avanzarPagina() {
                    if ($scope.currentPage < $scope.lastPage) {
                        $scope.selectPage($scope.currentPage + 1);
                        $scope.selectedCobranza = 0;
                    }
                }
            }
        ]
    );
